package luento04;

/**
 * @author vesal
 * @version 17.1.2023
 *
 */
public class Alkuluku {

    /**
     * Funktiolla tutkitaan onko parametrina tuotu
     * luku alkuluku vai ei<br>
     * Algoritmi: Jaetaan tutkittavaa lukua jakajilla 2,3,5,7...luku/2.
     * Jos jokin jako menee tasan, niin ei alkuluku:      
     * @param luku tutkittava luku
     * @return luvun jolla jaollinen tai 1 jos alkuluku
     * @example
     * <pre name="test">
     *   millaJaollinen(1)   === 1;
     *   millaJaollinen(25)  === 5;
     *   millaJaollinen(2)   === 1;
     *   millaJaollinen(4)   === 2;
     *   millaJaollinen(123) === 3;
     *   millaJaollinen(7)   === 1;     
     * </pre>
     */
    public static int millaJaollinen(int luku) {
        int jakaja = 2;
        int kasvatus = 1;
        if (luku==2) return 1;
        do {
            int jakojaannos = luku % jakaja;
            if (jakojaannos == 0) return jakaja;
            jakaja += kasvatus;
            kasvatus = 2;
        } while ( jakaja < luku/2); 
        return 1;
    }
    
    /**
     * @param args ei käytössä
     */
    public static void main(String[] args) {
        int luku = 25;
        int jaollinen;
        
        jaollinen = millaJaollinen(luku);
        if ( jaollinen == 1)
            System.out.println("alkuluku");
         else
            System.out.println("Jaollinen luvulla " + jaollinen);
    }
}
